#!/usr/bin/perl

use GD;
use strict;

# cnt.pl
# (c) Alexandr A Alexeev 2009, http://eax.me/


my $png = shift;
my $log = shift;

unless($png && $log) {
  print "usage: $0 outfile.png stat.log\n";
  exit 1;
}

chomp(my $rss = `./feedburner-grab.pl web20su`);
if($?) {
  print "feedburner-grab returns $?\n";
  exit 3;
} 

#chomp(my $email = `./subscribe-grab.pl inet.thoughts.web20su`);
chomp(my $email = `./feedburner-grab.pl web20su_email`);
if($?) {
  print "email-grab returns $?\n";
  exit 4;
}

chomp(my $lj = `./livejournal-grab.pl web20su.livejournal.com`); 
if($?) {
  print "livejournal-grab returns $?\n";
  exit 5;
}

chomp(my $twitter = `./twitter-grab.pl web20su`); 
if($?) {
  print "twitter-grab returns $?\n";
  exit 6;
}

my $none = "---split---";

chomp(my $pr = `./google-grab.pl web20.su`);
if($?) {
  print "google-grab returns $?\n";
  exit 7;
}

chomp(my $ya = `./yandex-grab.pl web20.su`);
if($?) {
  print "yandex-grab returns $?\n";
  exit 8;
}

open LOG, ">>$log" or die "Failed to open $log\n";
chomp(my $date = `date "+%Y-%m-%d"`);
print LOG "date=$date:rss=$rss:email=$email:lj=$lj:twitter=$twitter:pr=$pr:ya=$ya\n";
close LOG;


my $im = new GD::Image("template.png");
my $top = 3;

foreach my $i ($rss, $email, $lj, $twitter, $none, $pr, $ya) {
  if($i ne "---split---") {
    $im->line(84-6*length($i), $top+10, 87, $top+10, 0);
    $im->string(gdSmallFont, 84-6*length($i), $top, $i, 2);
    $top += 10;
  }
  $top += 6;
}

open PNG, ">$png" or die "Failed to open $png\n";
binmode PNG;
print PNG $im->png;
close PNG;

exit 0;

